diff -crN nakedmudv2.0/src/auxiliary.c nakedmudv2.1/src/auxiliary.c
*** nakedmudv2.0/src/auxiliary.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/auxiliary.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 40,46 ****
  //*****************************************************************************
  
  void init_auxiliaries() {
!   auxiliary_manip_funcs = newHashtable(100);
  }
  
  AUXILIARY_FUNCS *
--- 40,46 ----
  //*****************************************************************************
  
  void init_auxiliaries() {
!   auxiliary_manip_funcs = newHashtable();
  }
  
  AUXILIARY_FUNCS *
***************
*** 85,91 ****
  
  HASHTABLE *
  newAuxiliaryData(bitvector_t aux_type) {
!   HASHTABLE        *data = newHashtable(10);
    HASH_ITERATOR  *hash_i = newHashIterator(auxiliary_manip_funcs);
    AUXILIARY_FUNCS *funcs = NULL;
    const char       *name = NULL;
--- 85,91 ----
  
  HASHTABLE *
  newAuxiliaryData(bitvector_t aux_type) {
!   HASHTABLE        *data = newHashtableSize(25);
    HASH_ITERATOR  *hash_i = newHashIterator(auxiliary_manip_funcs);
    AUXILIARY_FUNCS *funcs = NULL;
    const char       *name = NULL;
***************
*** 147,153 ****
  
  HASHTABLE *
  auxiliaryDataRead(STORAGE_SET *set, bitvector_t aux_type) {
!   HASHTABLE        *data = newHashtable(10);
    HASH_ITERATOR  *hash_i = newHashIterator(auxiliary_manip_funcs);
    AUXILIARY_FUNCS *funcs = NULL;
    const char       *name = NULL;
--- 147,153 ----
  
  HASHTABLE *
  auxiliaryDataRead(STORAGE_SET *set, bitvector_t aux_type) {
!   HASHTABLE        *data = newHashtableSize(25);
    HASH_ITERATOR  *hash_i = newHashIterator(auxiliary_manip_funcs);
    AUXILIARY_FUNCS *funcs = NULL;
    const char       *name = NULL;
***************
*** 193,199 ****
  
  HASHTABLE *
  auxiliaryDataCopy(HASHTABLE *data) {
!   HASHTABLE *newdata = newHashtable(10);
    auxiliaryDataCopyTo(data, newdata);
    return newdata;
  }
--- 193,199 ----
  
  HASHTABLE *
  auxiliaryDataCopy(HASHTABLE *data) {
!   HASHTABLE *newdata = newHashtableSize(25);
    auxiliaryDataCopyTo(data, newdata);
    return newdata;
  }
diff -crN nakedmudv2.0/src/bitvector.c nakedmudv2.1/src/bitvector.c
*** nakedmudv2.0/src/bitvector.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/bitvector.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 47,57 ****
  //*****************************************************************************
  // local functions, datastructures, and defines
  //*****************************************************************************
- 
- // optimally, this should be about 120% bigger than the number
- // of distinct types of bitvectors we'd expect to have in the game
- #define BITVECTOR_TABLE_SIZE      50
- 
  // a table of mappings between bitvector names, and the 
  // data assocciated with them (i.e. bit:value mappings)
  HASHTABLE *bitvector_table = NULL;
--- 47,52 ----
***************
*** 68,74 ****
  
  BITVECTOR_DATA *newBitvectorData(const char *name) {
    BITVECTOR_DATA *data = malloc(sizeof(BITVECTOR_DATA));
!   data->bitmap = newHashtable(32);
    data->name   = strdup(name);
    return data;
  }
--- 63,69 ----
  
  BITVECTOR_DATA *newBitvectorData(const char *name) {
    BITVECTOR_DATA *data = malloc(sizeof(BITVECTOR_DATA));
!   data->bitmap = newHashtable();
    data->name   = strdup(name);
    return data;
  }
***************
*** 81,87 ****
  //*****************************************************************************
  void init_bitvectors() {
    // create the bitvector table
!   bitvector_table = newHashtable(BITVECTOR_TABLE_SIZE);
  
    // and also create some of the basic bitvectors and 
    // bits that come stock and are required for the core release
--- 76,82 ----
  //*****************************************************************************
  void init_bitvectors() {
    // create the bitvector table
!   bitvector_table = newHashtable();
  
    // and also create some of the basic bitvectors and 
    // bits that come stock and are required for the core release
***************
*** 248,250 ****
--- 243,253 ----
    deleteHashIterator(hash_i);
    return bits;
  }
+ 
+ int bitvectorSize(BITVECTOR *v) {
+   return hashSize(v->data->bitmap);
+ }
+ 
+ LIST *bitvectorListBits(BITVECTOR *v) {
+   return hashCollect(v->data->bitmap);
+ }
diff -crN nakedmudv2.0/src/bitvector.h nakedmudv2.1/src/bitvector.h
*** nakedmudv2.0/src/bitvector.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/bitvector.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 97,100 ****
--- 97,110 ----
  // return a comma-separated list of the bits the vector has set
  const char *bitvectorGetBits(BITVECTOR *v);
  
+ //
+ // returns the number of possible bits that can be set on this bitvector
+ int bitvectorSize(BITVECTOR *v);
+ 
+ //
+ // return a list of the possible bits that this vector can have set. The list
+ // must be deleted after use, as well as all the contents. 
+ // try: listDeleteWith(list, free)
+ LIST *bitvectorListBits(BITVECTOR *v);
+ 
  #endif // BITVECTOR_H
diff -crN nakedmudv2.0/src/character.h nakedmudv2.1/src/character.h
*** nakedmudv2.0/src/character.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/character.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 19,26 ****
  // the difference between newChar and newMobile is that newMobile
  // assigned a new UID whereas newChar does not.
  //
! CHAR_DATA   *newChar          ();
! CHAR_DATA    *newMobile       ();
  void         deleteChar       (CHAR_DATA *mob);
  
  CHAR_DATA    *charRead        (STORAGE_SET *set);
--- 19,26 ----
  // the difference between newChar and newMobile is that newMobile
  // assigned a new UID whereas newChar does not.
  //
! CHAR_DATA   *newChar          (void);
! CHAR_DATA    *newMobile       (void);
  void         deleteChar       (CHAR_DATA *mob);
  
  CHAR_DATA    *charRead        (STORAGE_SET *set);
diff -crN nakedmudv2.0/src/char_vars/char_vars.c nakedmudv2.1/src/char_vars/char_vars.c
*** nakedmudv2.0/src/char_vars/char_vars.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/char_vars/char_vars.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 24,32 ****
  //
  //*****************************************************************************
  
- // the size of the hashtable we store char vars in
- #define CHAR_VAR_TABLE_SIZE   10
- 
  // used in storage_sets to keep track of what kind of data we're saving
  const char *char_var_types[] = {
    "string",
--- 24,29 ----
***************
*** 117,123 ****
    // Hashtables can take up lots of storage space. Because of this, let's
    // not create any tables until it's actually needed. This will cut down
    // on lots of memory usage w.r.t. NPCs who do not use character variables
!   //  data->char_vars        = newHashtable(CHAR_VAR_TABLE_SIZE);
    data->char_vars         = NULL;
    return data;
  }
--- 114,120 ----
    // Hashtables can take up lots of storage space. Because of this, let's
    // not create any tables until it's actually needed. This will cut down
    // on lots of memory usage w.r.t. NPCs who do not use character variables
!   //  data->char_vars        = newHashtable();
    data->char_vars         = NULL;
    return data;
  }
***************
*** 146,152 ****
    if(from_size > 0) {
      // make sure the "to" table exists
      if(to->char_vars == NULL)
!       to->char_vars = newHashtable(CHAR_VAR_TABLE_SIZE);
  
      // copy everything over
      HASH_ITERATOR *from_i = newHashIterator(from->char_vars);
--- 143,149 ----
    if(from_size > 0) {
      // make sure the "to" table exists
      if(to->char_vars == NULL)
!       to->char_vars = newHashtable();
  
      // copy everything over
      HASH_ITERATOR *from_i = newHashIterator(from->char_vars);
***************
*** 194,200 ****
  
  
  HASHTABLE *variableRead(STORAGE_SET *set) {
!   HASHTABLE *table       = newHashtable(CHAR_VAR_TABLE_SIZE);
    STORAGE_SET_LIST *list = read_list(set, "list");
    STORAGE_SET *var       = NULL;
  
--- 191,197 ----
  
  
  HASHTABLE *variableRead(STORAGE_SET *set) {
!   HASHTABLE *table       = newHashtable();
    STORAGE_SET_LIST *list = read_list(set, "list");
    STORAGE_SET *var       = NULL;
  
***************
*** 212,218 ****
    CHAR_VAR_AUX_DATA *data = newCharVarAuxData();
    STORAGE_SET_LIST  *list = read_list(set, "variables");
    STORAGE_SET    *var_set = NULL;
!   data->char_vars         = newHashtable(CHAR_VAR_TABLE_SIZE);
    
    while( (var_set = storage_list_next(list)) != NULL) {
      const char *var_type = read_string(var_set, "type");
--- 209,215 ----
    CHAR_VAR_AUX_DATA *data = newCharVarAuxData();
    STORAGE_SET_LIST  *list = read_list(set, "variables");
    STORAGE_SET    *var_set = NULL;
!   data->char_vars         = newHashtable();
    
    while( (var_set = storage_list_next(list)) != NULL) {
      const char *var_type = read_string(var_set, "type");
***************
*** 292,298 ****
    CHAR_VAR_AUX_DATA *data = charGetAuxiliaryData(ch, "char_var_aux_data");
    CHAR_VAR *old = (data->char_vars ? hashRemove(data->char_vars, key) : NULL);
    if(data->char_vars == NULL && val != 0)
!     data->char_vars = newHashtable(CHAR_VAR_TABLE_SIZE);
    if(old != NULL) 
      deleteCharVar(old);
    if(val != 0)
--- 289,295 ----
    CHAR_VAR_AUX_DATA *data = charGetAuxiliaryData(ch, "char_var_aux_data");
    CHAR_VAR *old = (data->char_vars ? hashRemove(data->char_vars, key) : NULL);
    if(data->char_vars == NULL && val != 0)
!     data->char_vars = newHashtable();
    if(old != NULL) 
      deleteCharVar(old);
    if(val != 0)
***************
*** 304,310 ****
    CHAR_VAR_AUX_DATA *data = charGetAuxiliaryData(ch, "char_var_aux_data");
    CHAR_VAR *old = (data->char_vars ? hashRemove(data->char_vars, key) : NULL);
    if(data->char_vars == NULL && val != 0)
!     data->char_vars = newHashtable(CHAR_VAR_TABLE_SIZE);
    if(old != NULL) 
      deleteCharVar(old);
    if(val != 0)
--- 301,307 ----
    CHAR_VAR_AUX_DATA *data = charGetAuxiliaryData(ch, "char_var_aux_data");
    CHAR_VAR *old = (data->char_vars ? hashRemove(data->char_vars, key) : NULL);
    if(data->char_vars == NULL && val != 0)
!     data->char_vars = newHashtable();
    if(old != NULL) 
      deleteCharVar(old);
    if(val != 0)
***************
*** 316,322 ****
    CHAR_VAR_AUX_DATA *data = charGetAuxiliaryData(ch, "char_var_aux_data");
    CHAR_VAR *old = (data->char_vars ? hashRemove(data->char_vars, key) : NULL);
    if(data->char_vars == NULL && val != 0)
!     data->char_vars = newHashtable(CHAR_VAR_TABLE_SIZE);
    if(old != NULL) 
      deleteCharVar(old);
    if(val != 0)
--- 313,319 ----
    CHAR_VAR_AUX_DATA *data = charGetAuxiliaryData(ch, "char_var_aux_data");
    CHAR_VAR *old = (data->char_vars ? hashRemove(data->char_vars, key) : NULL);
    if(data->char_vars == NULL && val != 0)
!     data->char_vars = newHashtable();
    if(old != NULL) 
      deleteCharVar(old);
    if(val != 0)
***************
*** 328,334 ****
    CHAR_VAR_AUX_DATA *data = charGetAuxiliaryData(ch, "char_var_aux_data");
    CHAR_VAR *old = (data->char_vars ? hashRemove(data->char_vars, key) : NULL);
    if(data->char_vars == NULL && *val != '\0') 
!     data->char_vars = newHashtable(CHAR_VAR_TABLE_SIZE);
    if(old != NULL) 
      deleteCharVar(old);
    if(*val != '\0')
--- 325,331 ----
    CHAR_VAR_AUX_DATA *data = charGetAuxiliaryData(ch, "char_var_aux_data");
    CHAR_VAR *old = (data->char_vars ? hashRemove(data->char_vars, key) : NULL);
    if(data->char_vars == NULL && *val != '\0') 
!     data->char_vars = newHashtable();
    if(old != NULL) 
      deleteCharVar(old);
    if(*val != '\0')
diff -crN nakedmudv2.0/src/cmd_admin.c nakedmudv2.1/src/cmd_admin.c
*** nakedmudv2.0/src/cmd_admin.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/cmd_admin.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 275,280 ****
--- 275,281 ----
      send_to_char(ch, "But you're already visible!\r\n");
    else {
      charSetImmInvis(ch, 0);
+     send_to_char(ch, "You fade into existence.\r\n");
      message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
  	    "$n slowly fades into existence.");
    }
diff -crN nakedmudv2.0/src/cmd_builder.c nakedmudv2.1/src/cmd_builder.c
*** nakedmudv2.0/src/cmd_builder.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/cmd_builder.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 122,128 ****
  // usage: fill [dir]
  //
  COMMAND(cmd_fill) {
-   char buf[MAX_INPUT_LEN];
    int dir;
  
    if(!arg || !*arg) {
--- 122,127 ----
***************
*** 130,145 ****
      return;
    }
  
!   sscanf(arg, "%s", buf);
!   dir = dirGetNum(buf);
  
    if(dir == DIR_NONE)
!     dir = dirGetAbbrevNum(buf);
  
    if(!canEditZone(worldZoneBounding(gameworld,roomGetVnum(charGetRoom(ch))),ch))
      send_to_char(ch, "You are not authorized to edit this zone.\r\n");
    else if(dir == DIR_NONE)
!     try_specfill(ch, buf);
    else if(!roomGetExit(charGetRoom(ch), dir))
      send_to_char(ch, "There doesn't seem to be an exit in that direction.\r\n");
    else {
--- 129,143 ----
      return;
    }
  
!   dir = dirGetNum(arg);
  
    if(dir == DIR_NONE)
!     dir = dirGetAbbrevNum(arg);
  
    if(!canEditZone(worldZoneBounding(gameworld,roomGetVnum(charGetRoom(ch))),ch))
      send_to_char(ch, "You are not authorized to edit this zone.\r\n");
    else if(dir == DIR_NONE)
!     try_specfill(ch, arg);
    else if(!roomGetExit(charGetRoom(ch), dir))
      send_to_char(ch, "There doesn't seem to be an exit in that direction.\r\n");
    else {
***************
*** 148,155 ****
  
      exit_to = worldGetRoom(gameworld,
  			   exitGetTo(roomGetExit(charGetRoom(ch), dir)));
!     exit_back = roomGetExit(exit_to,
! 			    dirGetOpposite(dir));
  
      // see if the room we're filling leads back to us... if so, fill it in
      if(exit_back &&
--- 146,153 ----
  
      exit_to = worldGetRoom(gameworld,
  			   exitGetTo(roomGetExit(charGetRoom(ch), dir)));
!     if(exit_to)
!       exit_back = roomGetExit(exit_to, dirGetOpposite(dir));
  
      // see if the room we're filling leads back to us... if so, fill it in
      if(exit_back &&
***************
*** 326,335 ****
  }
  
  
  //*****************************************************************************
  //
  // Functions for listing different types of data (zones, mobs, objs, etc...)
- //
  //*****************************************************************************
  const char *charGetListType(CHAR_DATA *ch) {
    return charGetRace(ch);
--- 324,389 ----
  }
  
  
+ 
+ //*****************************************************************************
+ // Functions for deleting different prototype
  //*****************************************************************************
+ 
+ 
  //
+ // Delete an object, room, mobile, etc... from the game. First remove it from
+ // the gameworld, and then delete it and its contents. The onus is on the 
+ // builder to make sure deleting a prototype won't screw anything up (e.g.
+ // people standing about in a room when it's deleted).
+ void do_delete(CHAR_DATA *ch, void *remover, void *deleter, 
+ 	       const char *datatype, const char *arg) {
+   void *(* remove_func)(WORLD_DATA *world, int vnum) = remover;
+   void  (* delete_func)(void *data)                  = deleter;
+   
+   if(!arg || !*arg || !isdigit(*arg))
+     send_to_char(ch, "Which %s did you want to delete?\r\n", datatype);
+   else {
+     int vnum = atoi(arg);
+     ZONE_DATA *zone = worldZoneBounding(gameworld, vnum);
+     if(zone == NULL || !canEditZone(zone, ch))
+       send_to_char(ch, "You are not authorized to edit that zone.\r\n");
+     else {
+       void *data = remove_func(gameworld, vnum);
+       if(data == NULL)
+ 	send_to_char(ch, "%s %d does not exist.\r\n", datatype, vnum);
+       else {
+ 	send_to_char(ch, "%s %d deleted.\r\n", datatype, vnum);
+ 	delete_func(data);
+ 	worldSave(gameworld, WORLD_PATH);
+       }
+     }
+   }
+ }
+ 
+ COMMAND(cmd_scdelete) {
+   do_delete(ch, worldRemoveScriptVnum, deleteScript, "script", arg);
+ }
+ 
+ COMMAND(cmd_rdelete) {
+   do_delete(ch, worldRemoveRoomVnum, deleteRoom, "room", arg);
+ }
+ 
+ COMMAND(cmd_mdelete) {
+   do_delete(ch, worldRemoveMobVnum, deleteChar, "mob", arg);
+ }
+ 
+ COMMAND(cmd_odelete) {
+   do_delete(ch, worldRemoveObjVnum, deleteObj, "obj", arg);
+ }
+ 
+ COMMAND(cmd_ddelete) {
+   do_delete(ch, worldRemoveDialogVnum, deleteDialog, "dialog", arg);
+ }
+ 
+ 
+ 
+ //*****************************************************************************
  // Functions for listing different types of data (zones, mobs, objs, etc...)
  //*****************************************************************************
  const char *charGetListType(CHAR_DATA *ch) {
    return charGetRace(ch);
diff -crN nakedmudv2.0/src/commands.h nakedmudv2.1/src/commands.h
*** nakedmudv2.0/src/commands.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/commands.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 27,39 ****
  COMMAND(cmd_load);
  COMMAND(cmd_purge);
  COMMAND(cmd_zreset);
  COMMAND(cmd_sclist);
  COMMAND(cmd_rlist);
  COMMAND(cmd_mlist);
  COMMAND(cmd_olist);
  COMMAND(cmd_dlist);
  COMMAND(cmd_zlist);
! COMMAND(cmd_buildwalk);
  
  
  /* cmd_manip.c */
--- 27,44 ----
  COMMAND(cmd_load);
  COMMAND(cmd_purge);
  COMMAND(cmd_zreset);
+ COMMAND(cmd_buildwalk);
  COMMAND(cmd_sclist);
  COMMAND(cmd_rlist);
  COMMAND(cmd_mlist);
  COMMAND(cmd_olist);
  COMMAND(cmd_dlist);
  COMMAND(cmd_zlist);
! COMMAND(cmd_scdelete);
! COMMAND(cmd_rdelete);
! COMMAND(cmd_mdelete);
! COMMAND(cmd_odelete);
! COMMAND(cmd_ddelete);
  
  
  /* cmd_manip.c */
diff -crN nakedmudv2.0/src/editor/editor.c nakedmudv2.1/src/editor/editor.c
*** nakedmudv2.0/src/editor/editor.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/editor/editor.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 57,65 ****
  // an editor for dialog. Essentially, text without newlines
  EDITOR *dialog_editor = NULL;
  
- // how many buckets are in our command table?
- #define EDITOR_CMD_TABLE_SIZE       20
- 
  struct editor_data {
    HASHTABLE *cmds;  // mappings from commands to their functions and descs
    void (* prompt)(SOCKET_DATA *sock); // the prompt display
--- 57,62 ----
***************
*** 194,199 ****
--- 191,198 ----
    int line = atoi(tmp);
    if(!isdigit(*tmp) || !bufferRemove(buf, line))
      text_to_buffer(sock, "Line does not exist.\r\n");
+   else
+     text_to_buffer(sock, "Line deleted.\r\n");
  }
  
  void editorEditLine(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
***************
*** 202,207 ****
--- 201,208 ----
    int line = atoi(tmp);
    if(!isdigit(*tmp) || !bufferReplaceLine(buf, arg, line))
      text_to_buffer(sock, "Line does not exist.\r\n");
+   else
+     text_to_buffer(sock, "Line replaced.\r\n");
  }
  
  void editorInsertLine(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
***************
*** 210,215 ****
--- 211,218 ----
    int line = atoi(tmp);
    if(!isdigit(*tmp) || !bufferInsert(buf, arg, line))
      text_to_buffer(sock, "Insertion failed.\r\n");
+   else
+     text_to_buffer(sock, "Line inserted.\r\n");
  }
  
  void editorListDialogBuffer(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
***************
*** 264,273 ****
--- 267,278 ----
  
  void editorClear(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
    bufferClear(buf);
+   text_to_buffer(sock, "Buffer cleared.\r\n");
  }
  
  void editorFormatBuffer(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
    bufferFormat(buf, 80, 3);
+   text_to_buffer(sock, "Buffer formatted.\r\n");
  }
  
  
***************
*** 293,299 ****
  EDITOR *newEditor() {
    EDITOR *editor = malloc(sizeof(EDITOR));
    // set up the default commands
!   editor->cmds = newHashtable(EDITOR_CMD_TABLE_SIZE);
    hashPut(editor->cmds, "q", 
  	  newEditorCommand("        Quit editor and save changes",
  			   editorQuit, TRUE));
--- 298,304 ----
  EDITOR *newEditor() {
    EDITOR *editor = malloc(sizeof(EDITOR));
    // set up the default commands
!   editor->cmds = newHashtable();
    hashPut(editor->cmds, "q", 
  	  newEditorCommand("        Quit editor and save changes",
  			   editorQuit, TRUE));
diff -crN nakedmudv2.0/src/hashtable.c nakedmudv2.1/src/hashtable.c
*** nakedmudv2.0/src/hashtable.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/hashtable.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 13,18 ****
--- 13,21 ----
  #include "list.h"
  #include "hashtable.h"
  
+ // how big of a size do our hashtables start out at?
+ #define DEFAULT_HASH_SIZE        5
+ 
  struct hashtable_iterator {
    int curr_bucket;
    HASHTABLE *table;
***************
*** 25,35 ****
--- 28,42 ----
  } HASH_ENTRY;
  
  struct hashtable {
+   int size;
    int num_buckets;
    LIST **buckets;
  };
  
  
+ //
+ // this is a fairly simple hashing function. It could do 
+ // with some major speeding up.
  int hash(const char *key) {
    int i;
    const int BASE = 2;
***************
*** 48,54 ****
  
  //
  // an internal form of hashGet that returns the entire entry (key and val)
- //
  HASH_ENTRY *hashGetEntry(HASHTABLE *table, const char *key){
    int bucket = hash(key) % table->num_buckets;
  
--- 55,60 ----
***************
*** 80,107 ****
  }
  
  
- //*****************************************************************************
  //
  // implementation of hashtable.h
  // documentation in hashtable.h
- //
  //*****************************************************************************
! HASHTABLE *newHashtable(int num_buckets) {
    int i;
!   HASHTABLE *table = malloc(sizeof(HASHTABLE));
    table->num_buckets = num_buckets;
    table->buckets = malloc(sizeof(LIST *) * num_buckets);
    for(i = 0; i < num_buckets; i++)
      table->buckets[i] = NULL;
    return table;
  }
  
  void  deleteHashtable(HASHTABLE *table) {
    int i;
    for(i = 0; i < table->num_buckets; i++) {
      if(table->buckets[i]) {
        HASH_ENTRY *entry = NULL;
!       while((entry=(HASH_ENTRY *)listPop(table->buckets[i])) !=NULL)
  	deleteHashtableEntry(entry);
        deleteList(table->buckets[i]);
      }
--- 86,135 ----
  }
  
  
  //
+ // Collect all of the HASH_ENTRYs in a hashtable into a single list
+ LIST *hashCollectEntries(HASHTABLE *table) {
+   LIST *list = newList();
+   int i;
+   for(i = 0; i < table->num_buckets; i++) {
+     if(table->buckets[i] == NULL) continue;
+     LIST_ITERATOR *list_i = newListIterator(table->buckets[i]);
+     HASH_ENTRY      *elem = NULL;
+     for(;(elem=listIteratorCurrent(list_i)) != NULL;listIteratorNext(list_i))
+       listPut(list, elem);
+     deleteListIterator(list_i);
+   }
+   return list;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
  // implementation of hashtable.h
  // documentation in hashtable.h
  //*****************************************************************************
! HASHTABLE *newHashtableSize(int num_buckets) {
    int i;
!   HASHTABLE *table   = malloc(sizeof(HASHTABLE));
    table->num_buckets = num_buckets;
+   table->size        = 0;
    table->buckets = malloc(sizeof(LIST *) * num_buckets);
    for(i = 0; i < num_buckets; i++)
      table->buckets[i] = NULL;
    return table;
  }
  
+ HASHTABLE *newHashtable(void) {
+   return newHashtableSize(DEFAULT_HASH_SIZE);
+ }
+ 
+ 
  void  deleteHashtable(HASHTABLE *table) {
    int i;
    for(i = 0; i < table->num_buckets; i++) {
      if(table->buckets[i]) {
        HASH_ENTRY *entry = NULL;
!       while((entry=listPop(table->buckets[i])) !=NULL)
  	deleteHashtableEntry(entry);
        deleteList(table->buckets[i]);
      }
***************
*** 111,116 ****
--- 139,175 ----
    free(table);
  }
  
+ 
+ //
+ // expand a hashtable to the new size
+ void hashExpand(HASHTABLE *table, int size) {
+   // collect all of the key:value pairs
+   LIST     *entries = hashCollectEntries(table);
+   HASH_ENTRY *entry = NULL;
+   int i;
+ 
+   // delete all of the current buckets
+   for(i = 0; i < table->num_buckets; i++) {
+     if(table->buckets[i] == NULL) continue;
+     deleteList(table->buckets[i]);
+   }
+   free(table->buckets);
+ 
+   // now, make new buckets and set them to NULL
+   table->buckets = malloc(sizeof(LIST *) * size);
+   bzero(table->buckets, sizeof(LIST *) * size);
+   table->num_buckets = size;
+ 
+   // now, we put all of our entries back into the new buckets
+   while((entry = listPop(entries)) != NULL) {
+     int bucket = hash(entry->key) % table->num_buckets;
+     if(table->buckets[bucket] == NULL) table->buckets[bucket] = newList();
+     listPut(table->buckets[bucket], entry);
+   }
+   deleteList(entries);
+ }
+ 
+ 
  int  hashPut    (HASHTABLE *table, const char *key, void *val) {
    HASH_ENTRY *elem = hashGetEntry(table, key);
  
***************
*** 120,125 ****
--- 179,188 ----
      return 1;
    }
    else {
+     // first, see if we'll need to expand the table
+     if((table->size * 80)/100 > table->num_buckets)
+       hashExpand(table, (table->num_buckets * 150)/100);
+ 
      int bucket = hash(key) % table->num_buckets;
  
      // if the bucket doesn't exist yet, create it
***************
*** 128,133 ****
--- 191,197 ----
  
      HASH_ENTRY *entry = newHashtableEntry(key, val);
      listPut(table->buckets[bucket], entry);
+     table->size++;
      return 1;
    }
  }
***************
*** 158,163 ****
--- 222,228 ----
        void *val = elem->val;
        listRemove(table->buckets[bucket], elem);
        deleteHashtableEntry(elem);
+       table->size--;
        return val;
      }
      else
***************
*** 188,209 ****
  }
  
  int   hashSize   (HASHTABLE *table) {
!   int i;
!   int size = 0;
  
!   for(i = 0; i < table->num_buckets; i++)
!     if(table->buckets[i])
!       size += listSize(table->buckets[i]);
  
!   return size;
  }
  
  
  //*****************************************************************************
- //
  // implementation of the hashtable iterator
  // documentation in hashtable.h
- //
  //*****************************************************************************
  HASH_ITERATOR *newHashIterator(HASHTABLE *table) {
    HASH_ITERATOR *I = malloc(sizeof(HASH_ITERATOR));
--- 253,281 ----
  }
  
  int   hashSize   (HASHTABLE *table) {
!   return table->size;
! }
  
! LIST *hashCollect(HASHTABLE *table) {
!   LIST *list = newList();
!   int i;
  
!   for(i = 0; i < table->num_buckets; i++) {
!     if(table->buckets[i] == NULL) continue;
!     LIST_ITERATOR *list_i = newListIterator(table->buckets[i]);
!     HASH_ENTRY      *elem = NULL;
!     for(;(elem=listIteratorCurrent(list_i)) != NULL;listIteratorNext(list_i))
!       listPut(list, strdup(elem->key));
!     deleteListIterator(list_i);
!   }
!   return list;
  }
  
  
+ 
  //*****************************************************************************
  // implementation of the hashtable iterator
  // documentation in hashtable.h
  //*****************************************************************************
  HASH_ITERATOR *newHashIterator(HASHTABLE *table) {
    HASH_ITERATOR *I = malloc(sizeof(HASH_ITERATOR));
***************
*** 263,269 ****
    if(!I->bucket_i) 
      return NULL;
    else {
!     HASH_ENTRY *entry = ((HASH_ENTRY *) listIteratorCurrent(I->bucket_i));
      if(entry)
        return entry->key;
      else
--- 335,341 ----
    if(!I->bucket_i) 
      return NULL;
    else {
!     HASH_ENTRY *entry = listIteratorCurrent(I->bucket_i);
      if(entry)
        return entry->key;
      else
***************
*** 276,282 ****
    if(!I->bucket_i) 
      return NULL;
    else {
!     HASH_ENTRY *entry = ((HASH_ENTRY *) listIteratorCurrent(I->bucket_i));
      if(entry)
        return entry->val;
      else
--- 348,354 ----
    if(!I->bucket_i) 
      return NULL;
    else {
!     HASH_ENTRY *entry = listIteratorCurrent(I->bucket_i);
      if(entry)
        return entry->val;
      else
diff -crN nakedmudv2.0/src/hashtable.h nakedmudv2.1/src/hashtable.h
*** nakedmudv2.0/src/hashtable.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/hashtable.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 12,19 ****
  typedef struct hashtable                  HASHTABLE;
  typedef struct hashtable_iterator         HASH_ITERATOR;
  
  
- HASHTABLE *newHashtable(int num_buckets);
  void  deleteHashtable(HASHTABLE *table);
  
  int   hashPut    (HASHTABLE *table, const char *key, void *val);
--- 12,25 ----
  typedef struct hashtable                  HASHTABLE;
  typedef struct hashtable_iterator         HASH_ITERATOR;
  
+ //
+ // create a new hashtable with the specified number of buckets in it
+ HASHTABLE *newHashtableSize(int num_buckets);
+ 
+ //
+ // create a new hashtable. the default number of buckets are used
+ HASHTABLE *newHashtable(void);
  
  void  deleteHashtable(HASHTABLE *table);
  
  int   hashPut    (HASHTABLE *table, const char *key, void *val);
***************
*** 22,27 ****
--- 28,45 ----
  int   hashIn     (HASHTABLE *table, const char *key);
  int   hashSize   (HASHTABLE *table);
  
+ //
+ // expand a hashtable to the new size. Hashtables will automagically expand
+ // themselves as needed, but if you know that you are going to need a rather
+ // large hashtable apriori, you may wish to call this function after the table
+ // is created, to prevent unneccessary deallocations and reallocations of memory
+ void hashExpand(HASHTABLE *table, int size);
+ 
+ //
+ // returns a list of all the keys in the hashtable. The keys and the list
+ // must be deleted after use. Try: deleteListWith(list, free)
+ LIST *hashCollect(HASHTABLE *table);
+ 
  HASH_ITERATOR *newHashIterator     (HASHTABLE *table);
  void        deleteHashIterator     (HASH_ITERATOR *I);
  
***************
*** 30,34 ****
  const char *hashIteratorCurrentKey (HASH_ITERATOR *I);
  void       *hashIteratorCurrentVal (HASH_ITERATOR *I);
  
- 
  #endif // __HASHTABLE_H
--- 48,51 ----
